#!/bin/bash
# Automate MySQL install script: v. 0.5
# Written by: Georgi Dimitrov Georgiev - gdgeorgiev@hpe.com
# Completion date: 03.02.2016
# !! Use at your own risk !!

##domain=$1
##java_version=$2
##mysql_version=$3
##http=$4
##ajp=$5
##sdport=$6

# Define tomcat http port, ajp port, shutdown port and Proxy Url vars
port='3306'

# Set proxy url / port
proxy_url='http-proxy-ha.e-ssi.net:8080';
export https_proxy="$proxy_url"

# webdav host and dir - sl04097:/webdienste/dav/eoi/software # 

# Define download tomcat_url
mysql_url='https://webdav.intranet.eon-it.com/eoi/software/mysql';

# Define scripts download url
scripts_url='https://webdav.intranet.eon-it.com/eoi/software/scripts';

# Define avalable MySQL available versions
mysql[0]="mysql-5.0.96-linux-i686-glibc23.tar.gz";
mysql[1]="mysql-5.0.96-linux-x86_64-glibc23.tar.gz";
mysql[2]="mysql-5.1.72-linux-i686-glibc23.tar.gz";
mysql[3]="mysql-5.1.72-linux-x86_64-glibc23.tar.gz";
mysql[4]="mysql-5.5.48-linux2.6-i686.tar.gz";
mysql[5]="mysql-5.5.48-linux2.6-x86_64.tar.gz";
mysql[6]="mysql-5.6.29-linux-glibc2.5-i686.tar.gz";
mysql[7]="mysql-5.6.29-linux-glibc2.5-x86_64.tar.gz";
mysql[8]="mysql-5.7.10-linux-glibc2.5-i686.tar.gz";
mysql[9]="mysql-5.7.10-linux-glibc2.5-x86_64.tar.gz";

# Define java download url
##java_url='https://webdav.intranet.eon-it.com/eoi/software/java';
##java[0]="jdk-7u79-linux-i586.tar.gz";
##java[1]="jdk-7u79-linux-x64.tar.gz";
##java[2]="jdk-8u71-linux-i586.tar.gz";
##java[3]="jdk-8u71-linux-x64.tar.gz";

# Enumerate tomcat, java array count
mysql_cnt=${#mysql[@]};
##java_cnt=${#java[@]};


# Define mysql available versions
mysql_path='/webdienste/mysql';
##java_path='/webdienste/java/jdk';
temp_path='/webdienste/transfer/autoinstall';

###check_basic_args () {
###if [ "$#" -lt "5" ]; then
###echo "$0: not enough arguments.";
###echo "Usage: fqdn java_version mysql_version http_port ajp_port shutdown_port. Http and ajp are required."
###exit 2
###fi
###}

# Get domain and ip_address args
get_args () {
read -p "Domain: " domain;
read -p "IP Address: " ip_address;
read -p "Port [default is 3306]: " sdport;
if [ -z $sdport ]; then
sdport="$port";
##echo $sdport;
fi
##echo $sdport

if [[ "$domain" == '' ]] || [[ "$ip_address" == '' ]]; then
echo 'Missing or improper domain or IP address argument';
get_args;
fi

}

# Choose Tomcat / Java version
choose_version () { 
# Choose mysql version
##echo 'Choose Tomcat Version: ';
for i in $(seq 0 $(($mysql_cnt - 1))); do
echo "$i. ${mysql[$i]}";
done
read -p "Choose MySQL version:" mysql_version;
echo "$mysql_version";

if [[ mysql_version -ne "0" ]] && [[ mysql_version -ne "1" ]] && [[ mysql_version -ne "2" ]] && [[ mysql_version -ne "3" ]] && [[ mysql_version -ne "3" ]] && [[ mysql_version -ne "4" ]] && [[ mysql_version -ne "5" ]] && [[ mysql_version -ne "6" ]] && [[ mysql_version -ne "7" ]] && [[ mysql_version -ne "8" ]] && [[ mysql_version -ne "9" ]]; then
echo "Version doesnt exist";
exit 0;
fi
mysql_dir="$(echo ${mysql[$mysql_version]} | sed -e "s#.tar.gz##g")";

# Choose java version
##echo 'Choose Java Version';
###for i in $(seq 0 $(($java_cnt - 1))); do
###echo "$i. ${java[$i]}";
###done
###read -p "Choose Java version:" java_version;
###echo "$java_version";

###if [[ java_version -ne "1" ]] && [[ java_version -ne "2" ]] && [[ java_version -ne "3" ]] && [[ java_version -ne "3" ]] && [[ java_version -ne "4" ]]; then
###echo "Version doesnt exist";
###exit 0;
###fi

##java_dir="$(echo ${java[$java_version]} | sed -e "s#.tar.gz##g")";


}

#Download mysql

down_mysql () {
# check whether $temp_path exists and download mysql
if [ -d $temp_path ]; then
    cd $temp_path
    wget --no-check-certificate --timeout=5 $mysql_url/${mysql[$mysql_version]}
    tar zxvf ${mysql[$mysql_version]}
    wget --no-check-certificate --timeout=5 $scripts_url/mysql_template_files.tar.gz
    tar -zxvf mysql_template_files.tar.gz
    wget --no-check-certificate --timeout=5 $scripts_url/mysql-eis

else
mkdir $temp_path
    cd $temp_path
    wget --no-check-certificate --timeout=5 $mysql_url/${mysql[$mysql_version]}
    tar zxvf ${mysql[$mysql_version]}
    wget --no-check-certificate --timeout=5 $scripts_url/mysql_template_files.tar.gz
    tar -zxvf mysql_template_files.tar.gz
    wget --no-check-certificate --timeout=5 $scripts_url/mysql-eis
    
fi


#MySQL create dirs
if [[ ! -d "$mysql_path/${domain}" ]]; then
mkdir -p $mysql_path/${domain}
   cd $temp_path/$mysql_dir/
else
echo "Tomcat dir: temp_path/$mysql_dir already existing, will not create.";
exit 1;
fi

#Tomcat create dirs
if [[ ! -d "$mysql_path/product" ]]; then
mkdir -p $mysql_path/product
   cd $mysql_path/product/
else
echo "MySQL dir: mysql_path/$mysql_dir already existing, will not create.";
exit 1;
fi

if [ ! -f /etc/init.d/mysql-eis ]]; then
echo "Copying mysql-eis init script to /etc/init.d";
cp -rpf $temp_path/mysql-eis /etc/init.d;
chmod +x /etc/init.d/mysql-eis;
fi

# Disable unusued webapps if needed
##read -p 'Disable common default webapps {balancer,jsp-examples,servlets-examples,tomcat-docs,webdav} [Y/N]:' disable
##if [[ "$disable" == 'y' ]] || [[ "$disable" == 'Y' ]]; then
##echo 'Removing Read / Write / Exec access from {balancer,jsp-examples,servlets-examples,tomcat-docs,webdav,examples,host-manager,manager}';
##chmod 000 -R $temp_path/$tomcat_dir/webapps/{balancer,jsp-examples,servlets-examples,tomcat-docs,webdav,examples,host-manager,manager,docs} 2>&1 >/dev/null
##fi
echo "Copying $temp_path/$mysql_dir to $mysql_path/product";
cp -rpf $temp_path/$mysql_dir/ $mysql_path/product/
echo "Copying some standard conf files and structure to $mysql_path/$domain";
cp -rpf $temp_path/template/* $mysql_path/${domain}/

###cd $mysql_path/${domain}
###if [[ ! -L $mysql_path/$domain/current ]]; then
###ln -sf $(ls -1 $mysql_path/${domain}/) current
###fi

##    cd $mysql_path/${domain}/current/bin/
##    echo "Downloading with wget mysql-client.sh";
##    wget --no-check-certificate --timeout=5 $scripts_url/mysql-client.sh
##    chmod +x $mysql_path/${domain}/current/bin/mysql-client.sh

}

#Java create dirs

down_java () {
# get java dir var
java_dir="$(echo ${java[$version]} | sed -e "s#.tar.gz##g")";

# check whether temp_path exists and download java
if [ -d $temp_path ]; then
    cd $temp_path
    wget --no-check-certificate --timeout=5 $java_url/${java[$java_version]}
    tar zxvf ${java[$java_version]}
else
    mkdir -p $temp_path
    cd $temp_path
    wget --no-check-certificate --timeout=5 $java_url/${java[$java_version]}
    tar zxvf ${java[$java_version]}

fi


#Java create dir
##if [[ ! -d $java_path/${domain} ]]; then
##mkdir -p $java_path/${domain}/
##else
##echo "Will not create $java_path/$domain existing";
##exit 1;
##fi

# Copy extracted java to new domain dir
##echo "cp -rpf $temp_path/jdk*/ /webdienste/java/jdk/${domain}/"

# Create current symlink
##cd $java_path/${domain}/
##if [[ ! -L $java_path/$domain/current ]]; then
##ln -sf $(ls -1 $java_path/${domain}/) current
##fi
##cd $java_path/${domain}/current/bin/

}


#Change mysql config settings

fix_settings () {
#Change mysql settings
echo '------------------------------------------------';
echo "Changing BIND-ADDRESS, PORT, FQDN and MYSQL_VERSION in |my.cnf| Configurations ."

# set ip address of new Tomcat in server.xml
sed -i "s/<BIND-ADDRESS>/${ip_address}/g" $mysql_path/${domain}/conf/my.cnf

# set proper port in my.cnf
sed -i "s/<PORT>/${sdport}/" $mysql_path/${domain}/conf/my.cnf

# set proper domain url in my.cnf
sed -i "s/<FQDN>/${domain}/g" $mysql_path/${domain}/conf/my.cnf

if [[ -d $mysql_path/product ]]; then
cd $mysql_path/product
mysql_version=$(ls -d *);
echo $mysql_version;
else
echo "Something went wrong $mysql_path/product missing exiting";
exit 1
fi

# set proper mysql location dir in my.cnf
sed -i "s/<MYSQLVERSION>/${mysql_version}/g" $mysql_path/${domain}/conf/my.cnf

# Add to .activ_instances.lst isf not existing
if [[ $(grep "${domain}" $mysql_path/.activ_instances.lst 2>&1 >/dev/null) ]]; then 
echo "Will not add $domain to .active_instances.lst .. Existing."; 
else
echo "Adding $domain to $mysql_path/.activ_instances.lst";
echo "$domain" >> $mysql_path/.activ_instances.lst
fi
echo '---------------------------------';
echo "Creating basic datadir in $mysql_path/${domain}/data";
echo "$mysql_path/product/${mysql_version}/bin/mysqld --initialize --datadir=$mysql_path/${domain}/data";
echo '--------------- Command Output ----------------';

$mysql_path/product/${mysql_version}/bin/mysqld --initialize --datadir=$mysql_path/${domain}/data
}

# Start mysql
startup () {

# Launch MySQL
cd $mysql_path/${domain}/bin
echo '--------------------------------';
echo "Starting up MySQL for ${domain} with mysqlctl start";
sh mysqlctl start 
echo "If you need to stop mysql run $mysql_path/${domain}/bin/mysqlctl stop";
echo "Sleeping 10 seconds";
sleep 10;

# Show mysql.log messages
echo "mysql.log messages";
if [ -f $mysql_path/${domain}/logs/mysql.log ]; then
tail -n 50 $mysql_path/${domain}/logs/mysql.log
else
echo "mysql.log not found .. exiting";
exit 1;
fi

# Show mysql.err messages
echo "mysql.err messages";
if [ -f $mysql_path/${domain}/logs/mysql.err ]; then
tail -n 50 $mysql_path/${domain}/logs/mysql.err
else
echo "mysql.err not found .. exiting";
exit 1;
fi
echo '';
echo "Connect to the MySQL server and change the root password to the default one. For this purpose, edit the file:";
echo "/webdienste/mysql/test-eam-tool.intranet.eon.com/bin/mysql-client.sh";

}

# Cleanup obsolete created autinstall temp dir
cleanup () {
echo "Cleaning up everything in $temp_path";
rm -rf $temp_path/*

}

# Main 
main () {
###check_basic_args;
get_args;
choose_version;
down_mysql;
##down_java;
fix_settings;
##startup;
##cleanup;
}
main;
